/*______________________________________________________________________
  ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

                                   TestEmail

	Demo project to show how to use Mail component

	____________________________________________________________________

	File Name		: TestEmailDlg.cpp
	Date Initiated  : September 20, 2002
	Author          : Aisha Ikram ( ais_ikr@hotmail.com )
	Date Modified	: September 20, 2002  by Aisha Ikram

	____________________________________________________________________


  ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
  ----------------------------------------------------------------------*/


// TestEmailDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestEmail.h"
#include "TestEmailDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "Email/Email_i.c"
#import "Email/Email.dll" no_namespace
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestEmailDlg dialog

CTestEmailDlg::CTestEmailDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestEmailDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestEmailDlg)
	m_strTo = _T("");
	m_strAttachment = _T("");
	m_strSubject = _T("");
	m_strProfile = _T("TestProfile");
	m_strMessage = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestEmailDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestEmailDlg)
	DDX_Text(pDX, IDC_EDIT_TO, m_strTo);
	DDX_Text(pDX, IDC_EDIT_ATTACHMENTFILE, m_strAttachment);
	DDX_Text(pDX, IDC_EDIT_SUBJECT, m_strSubject);
	DDX_Text(pDX, IDC_EDIT_PROFILE, m_strProfile);
	DDX_Text(pDX, IDC_EDIT_MESSAGE, m_strMessage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestEmailDlg, CDialog)
	//{{AFX_MSG_MAP(CTestEmailDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_SEND, OnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestEmailDlg message handlers

BOOL CTestEmailDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestEmailDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestEmailDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestEmailDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//##//##/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  void CTestEmailDlg::OnSend() 
//
//    This module is called when send button is pressed and uses Email COM DLL to send email - Aisha Ikram
//
//##//##/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTestEmailDlg::OnSend() 
{
	UpdateData();
	try{
		
		CComPtr<IMail> objMail;
		
		HRESULT hr;
		// make sure the DLL is registered
		hr = objMail.CoCreateInstance(CLSID_Mail);
		if(SUCCEEDED(hr))
		{
			if(hr== S_OK)
			{
				// profile name is compulsory, this is the outlook profile, 
				// i used "outlook express" as configuring it is easier than "MS outlook"
				// make sure to specify the correct email sender's address for this profile
				// and make sure that outlook express or outlook is the default email client.
				if(m_strProfile.IsEmpty())
				{	
					AfxMessageBox("Please specify email profile name ");
					return;	
				}
				
				if(m_strTo.IsEmpty())
				{
					AfxMessageBox("Please specify recipient's email address ");
					return;
				}
				// by default, it's TestProfile, assumes that a profile with this name exists in outlook
				hr= objMail->put_strProfileName((_bstr_t)m_strProfile);
				
				hr = objMail->put_strSubject((_bstr_t)m_strSubject);
				
				// this is the email or set of email addresses (separated by ;)
				// which is actually used to send email			
				hr = objMail->put_strEmailAddress((_bstr_t)m_strTo);
				
				// recipient is just to show the display name
				hr= objMail->put_strRecipient((_bstr_t)m_strTo);
				
				hr = objMail->put_strAttachmentFilePath((_bstr_t)m_strAttachment);
				
				hr = objMail->put_strMessage((_bstr_t)m_strMessage);

				hr= objMail->Send();

				if(hr!=S_OK)
					AfxMessageBox("Error, make sure the information you are passing is correct");
			}
		}
	} // try
	catch(...)
	{
		AfxMessageBox("Error, make sure specified info is correct");
	}

}
